package lines

import (
	"git.k-space.ee/k-space/logmower-shipper/pkg/globals"
	prom "github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promauto"
)

const promSubsystem = "record"

var (
	promRecordDroppedTooLarge = promauto.NewCounterVec(prom.CounterOpts{
		Namespace: globals.PrometheusPrefix, // Subsystem: promSubsystem,
		Name:      "dropped_lines",          // "dropped",
		Help:      "Records dropped due to being too large",
	}, []string{"filename"})

	promRecordPrefixParsingErr = promauto.NewCounterVec(prom.CounterOpts{
		Namespace: globals.PrometheusPrefix, Subsystem: promSubsystem,
		Name: "parsing_errors",
		Help: "Errors while parsing log line prefixes",
	}, []string{"filename"})
)
