package watcher

import (
	"git.k-space.ee/k-space/logmower-shipper/pkg/globals"
	prom "github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promauto"
)

const promSubsystem = "watcher"

var (
	promWatcherOnline = promauto.NewGauge(prom.GaugeOpts{
		Namespace: globals.PrometheusPrefix, Subsystem: promSubsystem,
		Name: "online",
		Help: "1 if initialized, and directory watcher has been engaged successfully",
	})
	promWatcherErr = promauto.NewCounter(prom.CounterOpts{
		Namespace: globals.PrometheusPrefix, Subsystem: promSubsystem,
		Name: "errors",
		Help: "Error in logmower watching log files",
	})
	promWatcherFilesStarted = promauto.NewCounter(prom.CounterOpts{
		Namespace: globals.PrometheusPrefix, // Subsystem: promSubsystem,
		Name:      "log_file",               // "discovered_logfiles",
		Help:      "Number of tracked log files",
	})
	promWatcherFilesSkipped = promauto.NewCounter(prom.CounterOpts{
		Namespace: globals.PrometheusPrefix, // Subsystem: promSubsystem,
		Name:      "invalid_filename",       // "skipped_files",
		Help:      "Number of files in log directory skipped due to unexpected filename",
	})
	promWatcherEvents = promauto.NewCounter(prom.CounterOpts{
		Namespace: globals.PrometheusPrefix, // Subsystem: promSubsystem,
		Name:      "inotify_event",          // "events",
		Help:      "Number of events while watchng (includes initial create events for existing file discovery)",
	})
)
